#include <iostream>
#include <vector>

struct any {
    enum type {Int, Float, String};
    any(int   e) { data.INT    = e; type = Int;}
    any(float e) { data.FLOAT  = e; type = Float;}
    any(char* e) { data.STRING = e; type = String;}
    type get_type() const { return type; }
    int get_int() const { return data.INT; }
    float get_float() const { return data.FLOAT; }
    char* get_string() const { return data.STRING; }
private:
    type type;
    union {
        int   INT;
        float FLOAT;
        char *STRING;
    } data;
};

template <class ...Args>
void foo_imp(const Args&... args)
{
    std::vector<any> vec = {args...};
    for (unsigned i = 0; i < vec.size(); ++i) {
        switch (vec[i].get_type()) {
            case any::Int: std::cout << vec[i].get_int() << '\n'; break;
            case any::Float: std::cout << vec[i].get_float() << '\n'; break;
            case any::String: std::cout << vec[i].get_string() << '\n'; break;
        }
    }
}

template <class ...Args>
void foo(Args... args) {
    foo_imp(any(args)...);  //pass each arg to any constructor, and call foo_imp with resulting any objects
}

int main() {
    char s[] = "Hello";
    foo(1, 3.4f, s);
}